#ifdef WIN32
#pragma comment(lib, "c:\\TopfieldDisk\\DataFiles\\SDK\\TAP_SDK_DLL")
#include "TAP_Emulations.h"
#endif

#include "tap.h"
#include "RasterFontBrowser.h"
#include "tapapifix.h"
#include "Utils.h"
#include "Config.h"
//#ifndef WIN32
//#include "libFireBird.h"
//#endif
//#include <string.h>

#define ID_RBACK 0x8000aacc

TAP_ID( 0x8000aacc );
TAP_PROGRAM_NAME("Font Manager 1.0d");
TAP_AUTHOR_NAME("Justason/R2-D2/bellissimo/BobD");
TAP_DESCRIPTION("Manage TAP Fonts");
TAP_ETCINFO(__DATE__);

#include "TSRCommander.h"

bool debug = FALSE;

static bool options_displayed = FALSE, show_options_at_startup = FALSE, handle_initialisation;
static word region;
static dword state, sub_state = 0;
static TYPE_Window options_window;
static char preview_text[100] = "Jackdaws love my sphinx of quartz";

#define RKEY_White 		0x1003e
#define OSD_WHITE       "\x90[29]"

#define JUMP_CMD 0x08000000
#define NOP_CMD 0x00000000
#define REL_ADDR(x) (((dword)(x) & 0x0fffffff) >> 2)

dword hooked_PutS[2];
dword hooked_PutString[2];
dword hooked_PutStringAf[2];
dword hooked_GetW[2];

void applyHook()
{
#ifndef WIN32
   dword *f = (dword*)&TAP_Osd_PutS;
   f = (dword*)*f;
   if(f[1] != NOP_CMD)
   {
       if (debug) TAP_Print("Apply hook for PutS\n");
       if (debug) TAP_Print("%p %p %x\n",f,&TAP_Osd_PutS_HOOK,f[0]);
       hooked_PutS[0] = f[0];
       hooked_PutS[1] = f[1];
       f[0] = JUMP_CMD | REL_ADDR(&TAP_Osd_PutS_HOOK);
       f[1] = NOP_CMD;
       if (debug) TAP_Print("%p %p %x\n",f,&TAP_Osd_PutS_HOOK,f[0]);

	   if (hook_all) {
		   if (debug) TAP_Print("Apply hook for PutString\n");
		   f = (dword*)&TAP_Osd_PutString;
		   f = (dword*)*f;
		   hooked_PutString[0] = f[0];
		   hooked_PutString[1] = f[1];
		   f[0] = JUMP_CMD | REL_ADDR(&TAP_Osd_PutString_HOOK);
		   f[1] = NOP_CMD;
	   }

       if (debug) TAP_Print("Apply hook for PutStringAf\n");
       f = (dword*)&TAP_Osd_PutStringAf;
       f = (dword*)*f;
       hooked_PutStringAf[0] = f[0];
       hooked_PutStringAf[1] = f[1];
       f[0] = JUMP_CMD | REL_ADDR(&TAP_Osd_PutStringAf_HOOK);
       f[1] = NOP_CMD;

       if (debug) TAP_Print("Apply hook for GetW\n");
       f = (dword*)&TAP_Osd_GetW;
       f = (dword*)*f;
       hooked_GetW[0] = f[0];
       hooked_GetW[1] = f[1];
       f[0] = JUMP_CMD | REL_ADDR(&TAP_Osd_GetW_HOOK);
       f[1] = NOP_CMD;
   }
#endif
}

void removeHook()
{
#ifndef WIN32
   dword *f = (dword*)&TAP_Osd_PutS;
   f = (dword*)*f;
   if(f[1] == NOP_CMD)
   {
       if (debug) TAP_Print("Remove hook\n");

       f[0] = hooked_PutS[0];
       f[1] = hooked_PutS[1];

	   if (hook_all) {
		   f = (dword*)&TAP_Osd_PutString;
		   f = (dword*)*f;
		   f[0] = hooked_PutString[0];
		   f[1] = hooked_PutString[1];
	   }

       f = (dword*)&TAP_Osd_PutStringAf;
       f = (dword*)*f;
       f[0] = hooked_PutStringAf[0];
       f[1] = hooked_PutStringAf[1];

       f = (dword*)&TAP_Osd_GetW;
       f = (dword*)*f;
       f[0] = hooked_GetW[0];
       f[1] = hooked_GetW[1];
   }
#endif
} 

void clearOsd()
{
	TAP_Osd_FillBox(0, 0, 0, 720, 576, COLOR_None);
}

void drawOptionValues(dword selection)
{
	char buffer[100];
	dword w, offset_y = 115;
	word rgn = 0;

	w = TAP_Osd_GetW(fonts[current_font].font_name, 0, FNT_Size_1622);
	TAP_Osd_PutS(rgn, 400, offset_y, 570, fonts[current_font].font_name, (isMasterpiece() ? 0x15 : (selection == 0 ? options_window.win.color.titleText : options_window.win.color.bodyText)), COLOR_None, 0, FNT_Size_1622, FALSE, ALIGN_LEFT);

	TAP_SPrint(buffer, "%s", hook_all ? "Yes" : "No");
	TAP_Osd_PutS(rgn, 400, offset_y+22, 570, buffer, (isMasterpiece() ? 0x15 : (selection == 1 ? options_window.win.color.titleText : options_window.win.color.bodyText)), COLOR_None, 0, FNT_Size_1622, FALSE, ALIGN_LEFT);

	TAP_SPrint(buffer, "%s", "Press OK");
	w = TAP_Osd_GetW(buffer, 0, FNT_Size_1622);
	TAP_Osd_PutS(rgn, 400, offset_y+(22*2), 570, buffer, (isMasterpiece() ? 0x15 : (selection == 2 ? options_window.win.color.titleText : options_window.win.color.bodyText)), COLOR_None, 0, FNT_Size_1622, FALSE, ALIGN_LEFT);

	if (!isMasterpiece()) {
		TAP_Osd_FillBox(rgn, 150, offset_y+80, 420, 210, (isMasterpiece() ? 0xee : RGB8888(2,63,126)));
		TAP_SPrint(buffer, "Small: Height; %d  Baseline; %d", (current_font == 0) ? 0 : small_font.m_fontHeight, (current_font == 0) ? 0 : small_font.m_fontBaseline);
		TAP_Osd_PutS(rgn, 160, offset_y+100, 100+470, buffer, (isMasterpiece() ? 0x01 : RGB8888(150,150,150)), COLOR_None, 0, FNT_Size_1622, FALSE, ALIGN_LEFT);
		TAP_Osd_PutS(rgn, 160, offset_y+125, 100+470, preview_text, (isMasterpiece() ? 0x01 : RGB8888(204,204,204)), COLOR_None, 0, FNT_Size_1419, FALSE, ALIGN_LEFT);

		TAP_SPrint(buffer, "Medium: Heght; %d  Baseline; %d", current_font == 0 ? 0 : medium_font.m_fontHeight, current_font == 0 ? 0 : medium_font.m_fontBaseline);
		TAP_Osd_PutS(rgn, 160, offset_y+160, 100+470, buffer, (isMasterpiece() ? 0x01 : RGB8888(150,150,150)), COLOR_None, 0, FNT_Size_1622, FALSE, ALIGN_LEFT);
		TAP_Osd_PutS(rgn, 160, offset_y+185, 100+470, preview_text, (isMasterpiece() ? 0x01 : RGB8888(204,204,204)), COLOR_None, 0, FNT_Size_1622, FALSE, ALIGN_LEFT);

		TAP_SPrint(buffer, "Large: Height; %d  Baseline; %d", current_font == 0 ? 0 : large_font.m_fontHeight, current_font == 0 ? 0 : large_font.m_fontBaseline);
		TAP_Osd_PutS(rgn, 160, offset_y+220, 100+470, buffer, (isMasterpiece() ? 0x01 : RGB8888(150,150,150)), COLOR_None, 0, FNT_Size_1622, FALSE, ALIGN_LEFT);
		TAP_Osd_PutS(rgn, 160, offset_y+245, 100+470, preview_text, (isMasterpiece() ? 0x01 : RGB8888(204,204,204)), COLOR_None, 0, FNT_Size_1926, FALSE, ALIGN_LEFT);
	}

	if (isTF5800PVRt())
		TAP_Osd_PutString1419(rgn, 290, offset_y+305, -1, OSD_WHITE, COLOR_None, COLOR_None); 
	else
		TAP_Osd_FillBox(rgn, 290, offset_y+305, 15, 10, COLOR_White);
	TAP_Osd_PutS(rgn, 330, offset_y+303, -1, "Delete font", (isMasterpiece() ? 0x15 : options_window.win.color.bodyText), COLOR_None, 0, FNT_Size_1622, FALSE, ALIGN_LEFT);
}

void drawOptionsWindow(dword selection)
{
	TAP_ExitNormal();
	clearOsd();

	TAP_Win_Delete(&options_window);
	TAP_Win_SetDefaultColor(&options_window);
	TAP_Win_Create(&options_window, 0, 100, 60, 470, 320, FALSE, FALSE);

	TAP_Win_SetTitle(&options_window, "Font Manager Settings", 0, FNT_Size_1622);
	
	TAP_Win_AddItem(&options_window, "Choose font");
	TAP_Win_AddItem(&options_window, "Hook TAP_Osd_PutString");
	TAP_Win_AddItem(&options_window, "Exit Font Manager");

	TAP_Win_SetSelection(&options_window, selection);

	drawOptionValues(selection);
}

void handleInitialisation()
{
#ifndef WIN32
	//InitTAPex();
	InitTAPAPIFix();
#endif

	if (debug) TAP_Print("Load config\n");
	LoadConfiguration();
	if (debug) TAP_Print("Load fonts\n");
	loadFonts();

#ifndef WIN32
	if (debug) TAP_Print("Install as patch Fm\n");
	PatchInstallID((dword*) 0x80000000, "Fm");
#endif

	if (TAP_GetTick() > (100 * 60 * 3))
		TSRCommanderConfigDialog();
}

void handleIdleEvent()
{
	if (handle_initialisation) {
		handle_initialisation = FALSE;
		handleInitialisation();
		return;
	}
}

dword handleOptionsEventKeys(dword param1)
{
	dword selection = TAP_Win_GetSelection(&options_window);

	switch (param1) {

		case RKEY_Ok:

			switch (selection) {

				case 2:
					SaveConfigurationToFile();
					TSRCommanderExitTAP();
					TAP_Exit();
					break;

				default:
					break;
			}
			break;

		case RKEY_White:

			if (current_font > 0) {
				deleteFontFiles();
				shuffleFontsDown(current_font);

				TAP_Win_SetSelection(&options_window, selection);
				drawOptionsWindow(0);
			}
			break;

		case RKEY_VolDown:

			switch (selection) {
				
				case 0:
					current_font = (current_font - 1) < 0 ? font_count - 1 : current_font - 1;
					while (!isValidFont(current_font))
						current_font = (current_font - 1) < 1 ? font_count - 1 : current_font - 1;
					strcpy(font_name, fonts[current_font].font_name);
					switchFont();
					TAP_Win_SetSelection(&options_window, selection);
					drawOptionsWindow(0);
					break;

				case 1:
					if (!isMasterpiece()) {
						removeHook();
						switchHookAll();
						applyHook();
					}
					TAP_Win_SetSelection(&options_window, selection);
					drawOptionsWindow(1);
					break;
			}
			break;

		case RKEY_VolUp:

			switch (selection) {

				case 0:
					current_font = (current_font + 1) % font_count;
					while (!isValidFont(current_font))
						current_font = (current_font + 1) % font_count;
					strcpy(font_name, fonts[current_font].font_name);
					switchFont();
					TAP_Win_SetSelection(&options_window, selection);
					drawOptionsWindow(0);
					break;

				case 1:
					if (!isMasterpiece()) {
						removeHook();
						switchHookAll();
						applyHook();
					}
					TAP_Win_SetSelection(&options_window, selection);
					drawOptionsWindow(1);
					break;
			}
			break;

		case RKEY_Exit:

			SaveConfigurationToFile();
			TAP_Win_Delete(&options_window);
			clearOsd();
			TAP_EnterNormal();
			options_displayed = FALSE;
			break;

		default:

			TAP_Win_Action(&options_window, param1);
			TAP_Win_SetSelection(&options_window, TAP_Win_GetSelection(&options_window));
			drawOptionValues(TAP_Win_GetSelection(&options_window));
			break;
	}

	return 0;
}

dword TAP_EventHandler(word event, dword param1, dword param2)
{
    if (event == EVT_KEY)
    {
		if (options_displayed)
			return handleOptionsEventKeys(param1);

#ifndef WIN32
        if (param1 == RKEY_Slow)
        {
			TAP_GetState(&state, &sub_state);
			if (state != STATE_Menu || sub_state != SUBSTATE_MainMenu)
				return param1;
#else
		if (param1 == RKEY_Recall)
        {
#endif
            options_displayed = TRUE;
			loadNewFonts();
			drawOptionsWindow(0);
            return 0;
        }
    }
	ef (event == EVT_IDLE) 
	{
		handleIdleEvent();
	}

    return param1;
}

//----------------------------------------------------------------------------
// This function cleans up and closes the TAP
bool TSRCommanderExitTAP()
{
	TAP_Win_Delete(&options_window);
	clearOsd();
	TAP_EnterNormal();

	removeHook();
	deleteFont();

	return TRUE;
}


//-----------------------------------------------------------------------------
// This function displays a config menu
void TSRCommanderConfigDialog()
{
	options_displayed = TRUE;
	loadNewFonts();
	drawOptionsWindow(0);
}

TAP_Funcs _TF;

int TAP_Main(void)
{
#ifndef WIN32
_TF.MemAlloc = TAP_MemAlloc;
_TF.MemFree = TAP_MemFree;
_TF.Osd_FillBox = TAP_Osd_FillBox;
_TF.Osd_DrawPixmap = TAP_Osd_DrawPixmap;
_TF.Osd_GetPixel = TAP_Osd_GetPixel;
_TF.Osd_GetBaseInfo = TAP_Osd_GetBaseInfo;
_TF.Osd_PutString = TAP_Osd_PutString;
_TF.Osd_PutStringAf = TAP_Osd_PutStringAf;
_TF.Osd_PutS = TAP_Osd_PutS;
_TF.Osd_GetW = TAP_Osd_GetW;
_TF.Print = TAP_Print;
_TF.Delay = TAP_Delay;

	TAP_Print("@ %p\n",_tap_startAddr);
#endif

	handle_initialisation = TRUE;

#ifndef WIN32
	return 2;
#else
    return 1;
#endif
}

#ifdef WIN32
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
   // The following line sets some information in the SDK that will be available through the File->Info menuchoice
   setTAP_Information(__tap_program_name__, __tap_author_name__, __tap_description__, __tap_etc_str__, __tap_ud__);

   enableFramebufferUpdate(FALSE); // Set to TRUE to get all OSD output copied to framebuffer.
                                   // (available through GetBaseInfo). Setting this to TRUE will slow things down, so don't
                                   // use if you don't need it.

   enableFramebufferMonitor(FALSE); // Set to TRUE to get the SDK to copy any changed contents of the
                                    // framebuffer to the emulated screen. 

   return InitializeTAP_Environment(hInstance, nCmdShow, __tap_program_name__, TAP_Main, TAP_EventHandler);
} 
#endif
