#ifdef WIN32
#pragma comment(lib, "c:\\TopfieldDisk\\DataFiles\\SDK\\TAP_SDK_DLL")
#include "TAP_Emulations.h"
#endif

#include "tap.h"
#include "Utils.h"

char tmp[100];

void ChangeDirRoot()
{
	TYPE_File	fp;
	int		index;

	index = 0;
	TAP_Hdd_FindFirst(&fp);

    //	loop until root found, allow maximum of 20 levels
	while ((strcmp(fp.name, "__ROOT__") != 0) && (index++ < 20))
	{
		TAP_Hdd_ChangeDir("..");
		TAP_Hdd_FindFirst(&fp);
	}
}

bool ChangeDirProgramFiles(){
	ChangeDirRoot();
#ifndef WIN32
	return TAP_Hdd_ChangeDir("ProgramFiles");
#else
	return !TAP_Hdd_ChangeDir("ProgramFiles");
#endif
}

bool ChangeDirSettings(){
	ChangeDirProgramFiles();
#ifndef WIN32
	if (!TAP_Hdd_Exist("Settings"))
		TAP_Hdd_Create("Settings", ATTR_FOLDER);
	return TAP_Hdd_ChangeDir("Settings");
#else
	return !TAP_Hdd_ChangeDir("Settings");
#endif
}

bool ChangeDirFonts(){
	ChangeDirSettings();
#ifndef WIN32
	return TAP_Hdd_ChangeDir("Fonts");
#else
	return !TAP_Hdd_ChangeDir("Fonts");
#endif
}

bool isFont(char *name)
{
    strcpy(tmp, name);
    strlwr(tmp);

	if (strlen(tmp) < 5) return FALSE;

    if (strcmp(tmp + strlen(tmp) - 4, ".fnt" ) == 0)
        return TRUE;

    return FALSE;
}

// filter out punctuation from channel name, also filter special characters (for some German channels)
void stripSpecialCharacters(unsigned char *source, unsigned char *target)
{
	int len, i, j;
	int c;

	len = strlen(source);
	for (i = j = 0; i < len; i++) {

		c = source[i];

		// ignore special chars
		if (IS_CHAR_VALID(c)) {
			target[j] = source[i];
			j++;
		}
	}

	// terminate the new string
	target[j] = 0;
}

bool isTF58x0PVRt()
{
	word       SysID ;

#ifdef WIN32
	return FALSE;
#endif               

	SysID = *((volatile word*)0xa3fffffa);

    switch (SysID)
    {
		case 456:	
		case 457:	
		case 458:	
			return TRUE;

		default:	
			return FALSE;
    }

    return FALSE;
}

bool isTF5800PVRt()
{
	word       SysID ;

#ifdef WIN32
	return FALSE;
#endif               

	SysID = *((volatile word*)0xa3fffffa);

    switch (SysID)
    {
		case 456: return TRUE;
		default:  return FALSE;
    }

    return FALSE;
}

bool isMasterpiece()
{
   word       SysID ;

   //return TRUE;
   
#ifdef WIN32
	return FALSE;
#endif               

	SysID = *((volatile word*)0xa3fffffa);

  switch (SysID)
  {
    case  1416:
    case  1426:
    case  1456:
    case  1466:
    case  1486:
    case  2416:
    case  2446:
    case  2456:
    case  3416:
    case 21031:
    case 30002:
    case 40052:
      return TRUE;
      break;

    default:
      return FALSE;
      break;
  }
}
