/*
Copyright Pavel Kopylov

v. 1.08

25.09.2007
*/

#ifdef WIN32
#pragma comment(lib, "c:\\TopfieldDisk\\DataFiles\\SDK\\TAP_SDK_DLL")
#include "TAP_Emulations.h"
#endif

#include "tap.h"
#include "RasterFontBrowser.h"
#include "Utils.h"
#include "Config.h"
//#ifndef WIN32
//#include "libFireBird.h"
//#endif
//#include <string.h>
//#include <stdio.h>


#define htonl(A) ((((long)(A) & 0xff000000) >> 24) | (((long)(A) & 0x00ff0000) >> 8)  | (((long)(A) & 0x0000ff00) << 8)  | (((long)(A) & 0x000000ff) << 24)    )
#define max(a,b) (((a) > (b)) ? (a) : (b))
#define min(a,b) (((a) < (b)) ? (a) : (b))

#ifdef HOOK
#ifndef WIN32
#define HOOK_WRAP(FUNC,args...)	({TAP_Funcs * volatile _p = &_TF; _p->FUNC(args);})
#define TAP_MemAlloc(args...)	HOOK_WRAP(MemAlloc,##args)
#define TAP_MemFree(args...)	HOOK_WRAP(MemFree,##args)
#define TAP_Osd_FillBox(args...)	HOOK_WRAP(Osd_FillBox,##args)
#define TAP_Osd_DrawPixmap(args...)	HOOK_WRAP(Osd_DrawPixmap,##args)
#define TAP_Osd_GetPixel(args...)	HOOK_WRAP(Osd_GetPixel,##args)
#define TAP_Osd_GetBaseInfo(args...) HOOK_WRAP(Osd_GetBaseInfo,##args)
#define TAP_Osd_PutString(args...) HOOK_WRAP(Osd_PutString,##args)
#define TAP_Osd_PutStringAf(args...) HOOK_WRAP(Osd_PutStringAf,##args)
#define TAP_Osd_PutS(args...) HOOK_WRAP(Osd_PutS,##args)
#define TAP_Osd_GetW(args...) HOOK_WRAP(Osd_GetW,##args)
#define TAP_Print(args...)	HOOK_WRAP(Print,##args)
#define TAP_Delay(args...)	HOOK_WRAP(Delay,##args)
#endif

extern FONT FONT_SMALL;
extern FONT FONT_MEDIUM;
extern FONT FONT_BIG;
extern FONT FONT_NULL;
#endif // HOOK

int Load_Font_Height(FONT *font);
int Load_Font_Baseline(FONT *font);
int Load_Char_Table(FONT* font);
void FillImage(FONT *font, word *image, int width, int height);
void ComputeAntialiasingMap(FONT *font, word foreColor, word antialias_backColor, word backColor);
int CalcSize(FONT *font, unsigned char* text, int* width, int *text_length, byte bDot, int *len);
int RenderString(word region, FONT *font, unsigned char* text, int text_length, int width, word** image);

void draw_bitmap(FONT *font, unsigned char* bitmap, unsigned char *image, int width, int height, int x_offset, int y_offset, int bitmap_rows, int bitmap_width);

//////////////////////////////////////////////////////////////////////////
int TAP_Osd_PutS_Font(word rgn, dword x, dword y, dword maxX, unsigned char *str, word fcolor, word bcolor, FONT *font, byte align, byte bDot)
{
    int err=0; word antialias_bcolor = bcolor; unsigned char stripped_char[5000]; unsigned char *strToUse;
    
	if (isTF58x0PVRt()){strToUse=str;}
	else {
		stripSpecialCharacters(str, stripped_char);
		strToUse=stripped_char;		
	}

	if (bcolor == COLOR_None) {
		word word_pixel; byte byte_pixel;

		TAP_Osd_GetPixel(rgn, x, (y + font->m_fontHeight/2), &word_pixel);
		antialias_bcolor = word_pixel;
		
		SetColors(font, fcolor, antialias_bcolor, bcolor, 2);
	}
	else {
		SetColors(font, fcolor, antialias_bcolor, bcolor, 2);
	}

    err = TAP_Osd_PutS_FontL(rgn, x, y, maxX, strToUse, font, align, bDot);

    return err;
};


//////////////////////////////////////////////////////////////////////////
int TAP_Osd_PutS_FontEx(word rgn, dword x, dword y, dword maxX, dword maxY, int baseline_shift, unsigned char *str, word fcolor, word bcolor, FONT *font, byte align)
{
    font->m_fontHeight = max((int)maxY, font->m_fontHeight);
    if (font->m_bShifted==0)
    {
        font->m_fontBaseline += baseline_shift;
        font->m_bShifted=1;
    }
    return TAP_Osd_PutS_Font(rgn, x, y, maxX, str, fcolor, bcolor, font, align, 0);
};

//////////////////////////////////////////////////////////////////////////
int TAP_Osd_PutS_FontL(word rgn, dword x, dword y, dword maxX, unsigned char *str, FONT *font, byte align, byte bDot)
{
    int new_x;
    int width;
    int strlen_original, strlen_new;
    int err=0;
    word *image=0;

    // check that we are not drawing off the bottom of the screen or doing anything else stupid
	if (x >= 720 || y + font->m_fontHeight > 576 || (maxX > 0 && maxX <= x)) {
		//TAP_Print("Abort put\n");
        return 1;
	}

    // calculate max width (if maxX not defined, limit to screen width)
    width = (maxX == 0) ? 720 - x : min(720 - x, maxX - x);

    // calc the actual width of the string, limiting to max width
    err = CalcSize(font, (unsigned char *)str, &width, &strlen_new, bDot, &strlen_original);
    if (err != 0)
        return err;

    // Draw background rectangle
    if (font->m_backColor != COLOR_None) {
        if (maxX == 0 || maxX > 720)
            TAP_Osd_FillBox(rgn, x, y, width, font->m_fontHeight, font->m_backColor);
        else
            TAP_Osd_FillBox(rgn, x, y, min(720 - x, maxX - x), font->m_fontHeight, font->m_backColor);
    }

    // Decision of placement
    if (strlen_new < strlen_original)    // the required area is not enough for "str"
    {
        err = RenderString(rgn, font, str, strlen_new, width, &image);
        if (err==0)
        {
			//TAP_Print("Draw text image at x: %d, y: %d, maxX: %d, width: %d\n", x, y, maxX, width);
			TAP_Osd_DrawPixmap(rgn, (int)x, (int)y, width, font->m_fontHeight, image, TRUE, OSD_1555);
#ifndef NO_ALLOC
            TAP_MemFree(image);
#endif
        }
    }
    else
    {
        switch(align)
        {
        case ALIGN_LEFT:
            new_x = (int) min(720 - width, x);
            break;
        case ALIGN_CENTER:
			if ((maxX - x) <= width)
				new_x = x;
			else
				new_x = (int) min(720 - width, (x + (maxX - x - width) / 2));
            break;
        case ALIGN_RIGHT:
            new_x = (int) min(720 - width, maxX - width);
            break;
        }
        err = RenderString(rgn, font, (unsigned char*)str, strlen_original, width, &image);
        if (err==0)
        {
#ifndef WIN32
			//TAP_Print("Draw text image at x: %d, y: %d, maxX: %d, width: %d\n", new_x, y, maxX, width);
            TAP_Osd_DrawPixmap(rgn, new_x, (int)y, width, font->m_fontHeight, image, TRUE, OSD_1555);
#else
			int i, j;
			for (i = 0; i < width; i++)
				for (j = 0; j < font->m_fontHeight; j++)
					TAP_Osd_PutPixel(rgn, new_x+i, y+j, image[i + (j * width)]);
#endif

#ifndef NO_ALLOC
            TAP_MemFree(image);
#endif
        }
    }

    return err;
}

//////////////////////////////////////////////////////////////////////////
int Draw_Font_String(word region, dword x, dword y, char *str, char* fontname,  word foreColor, word backColor)
{
    int err1, width=0, text_length;
    FONT font;
    word *image=NULL;


    err1 = Load_Font(&font, fontname);
    if (err1==0)
    {
        SetColors(&font, COLOR_Yellow, COLOR_DarkBlue, COLOR_DarkBlue, 2);
        err1 = CalcSize(&font, (unsigned char *)str, &width, &text_length, 0, NULL);
        if (err1==0)
        {
            err1 = RenderString(region, &font, (unsigned char *)str, text_length, width, &image);
            if (err1==0)
            {
                TAP_Osd_DrawPixmap(region, x, y, width, font.m_fontHeight, image, TRUE, OSD_1555);
#ifndef NO_ALLOC
                TAP_MemFree(image);
#endif
            }
        }
        Delete_Font(&font);
    }

    return err1;
}

//////////////////////////////////////////////////////////////////////////
int Load_Font(FONT *font, char *fileName)
{
    int            ret=-1, read, err;
    TYPE_File    *f;
    long        flen;
    //char        msg[256];

	//TAP_Print("Load font %s\n", fileName);

#ifdef NO_ALLOC
    font->m_grayBuffer = NULL;
    font->m_wordBuffer = NULL;
#endif

    font->m_bShifted = 0;
    f = TAP_Hdd_Fopen(fileName);
    if (f!=0)
    {
        font->m_bmpHeaderArray=NULL;

        flen = TAP_Hdd_Flen(f);
        font->m_data = (unsigned char*)TAP_MemAlloc(flen);
        if (font->m_data!=NULL)
        {
            read = TAP_Hdd_Fread(font->m_data, flen, 1, f);
            TAP_Hdd_Fclose(f);
            if (read==1)
            {
                err = Load_Font_Height(font);
                if (err==0)
                {
                    //TAP_SPrint(msg, "height: %d", font->m_fontHeight);
                    //TAP_Osd_PutS(rgn, 50, 500, 150, msg, COLOR_Yellow, COLOR_DarkBlue, 0, FNT_Size_1419, 0, ALIGN_LEFT);
                    err = Load_Font_Baseline(font);
                    if (err==0)
                    {
                        //TAP_SPrint(msg, "baseline: %d", font->m_fontBaseline);
                        //TAP_Osd_PutS(rgn, 180, 500, 280, msg, COLOR_Yellow, COLOR_DarkBlue, 0, FNT_Size_1419, 0, ALIGN_LEFT);
                        err = Load_Char_Table(font);
                        if (err==0)
                        {
#ifdef NO_ALLOC
                            font->m_grayBuffer = (unsigned char*)TAP_MemAlloc(720 * font->m_fontHeight * sizeof(unsigned char));
                            font->m_wordBuffer = (word*)TAP_MemAlloc(720 * font->m_fontHeight * sizeof(word)); // word
                            if (font->m_grayBuffer==NULL || font->m_wordBuffer==NULL)
                            {
                                return 7;
                            }
							font->antialias_factor = antialias_override;
#endif
                            ret = 0;
                        }
                        else //Font table didn't load
                        {
                            ret = 6;
                        }
                    }
                    else //Font baseline not determined
                    {
                        ret = 5;
                    }
                }
                else //Font height not determined
                {
                    ret = 4;
                }
            }
            else //File didn't read
            {
                ret = 3;
            }
        }
        else // not enough memory
        {
            ret = 2;
        }
    }
    else
    {
        // File didn't open
        ret = 1;
    }

    return ret;
}

//////////////////////////////////////////////////////////////////////////
void Delete_Font(FONT *font)
{
#ifdef NO_ALLOC
    if (font->m_grayBuffer != NULL)
    {
        TAP_MemFree(font->m_grayBuffer);
		font->m_grayBuffer = NULL;
    }
    if (font->m_wordBuffer != NULL)
    {
        TAP_MemFree(font->m_wordBuffer);
		font->m_wordBuffer = NULL;
    }
#endif

    if (font != NULL)
    {
        TAP_MemFree(font->m_data);
		font->m_data = NULL;
    }
}

//////////////////////////////////////////////////////////////////////////
int Load_Font_Height(FONT *font)
{
    int error=1;
    long *ptr;


    if (font!=NULL)
    {
        ptr = (long*)(font->m_data);
        font->m_fontHeight = *ptr;
#ifdef _WIN32
        font->m_fontHeight = htonl(font->m_fontHeight);
#endif
        error=0;
    }

    return error;
}

//////////////////////////////////////////////////////////////////////////
int Load_Font_Baseline(FONT *font)
{
    int error=1;
    long *ptr;


    if (font!=NULL)
    {
        ptr = (long*)(font->m_data+4);
        font->m_fontBaseline = *ptr;
#ifdef _WIN32
        font->m_fontBaseline = htonl(font->m_fontBaseline);
#endif
        error=0;
    }

    return error;
}

//////////////////////////////////////////////////////////////////////////
int Load_Char_Table(FONT* font)
{
    int error=1;
#ifdef _WIN32
    int i;
#endif


    if (font!=NULL)
    {
        font->m_bmpHeaderArray = (TableItem*)(font->m_data+8);
        error=0;
    }

#ifdef _WIN32
    for (i=0; i<256; i++)
    {
        font->m_bmpHeaderArray[i].slot_advance_x = htonl(font->m_bmpHeaderArray[i].slot_advance_x);
        font->m_bmpHeaderArray[i].slot_advance_y = htonl(font->m_bmpHeaderArray[i].slot_advance_y);
        font->m_bmpHeaderArray[i].slot_bitmap_left = htonl(font->m_bmpHeaderArray[i].slot_bitmap_left);
        font->m_bmpHeaderArray[i].slot_bitmap_top = htonl(font->m_bmpHeaderArray[i].slot_bitmap_top);
        font->m_bmpHeaderArray[i].bitmap_rows = htonl(font->m_bmpHeaderArray[i].bitmap_rows);
        font->m_bmpHeaderArray[i].bitmap_width = htonl(font->m_bmpHeaderArray[i].bitmap_width);
        font->m_bmpHeaderArray[i].offset = htonl(font->m_bmpHeaderArray[i].offset);
    }
#endif

    return error;
}


//////////////////////////////////////////////////////////////////////////
void SetColors(FONT *font, word foreColor, word antialias_backColor, word backColor, word bytes_per_pixel)
{
	font->m_backColor=backColor;
	if (bytes_per_pixel == 2)
		ComputeAntialiasingMap(font, foreColor, antialias_backColor, backColor);
}

inline int CalcCharWidth(FONT *f, unsigned char c) 
{
//	return max(f->m_bmpHeaderArray[c].slot_advance_x, f->m_bmpHeaderArray[c].bitmap_width);
	return f->m_bmpHeaderArray[c].slot_advance_x;
}

//////////////////////////////////////////////////////////////////////////
int CalcSize(FONT *font, unsigned char* text, int* width, int *text_length, byte bDot, int *len)
{
	int pen_x, i, int_adv, err;
	bool cropped=FALSE;
	bool checkWidth;

    if (font==NULL || font->m_bmpHeaderArray==NULL)
    {
        return -1;
    }

    // MD Remove the left spacing before the first character
    if(text[0]){pen_x = -font->m_bmpHeaderArray[text[0]].slot_bitmap_left<<6;}
    else{pen_x=0;}

    if((*width)>0){checkWidth=TRUE;}
    else{checkWidth=FALSE;}
            
    // First calculating resulting bitmap size & cashing bitmaps
    i=0;
    while(text[i])
    {
        int_adv = CalcCharWidth(font, text[i]);
        
        if(checkWidth)
        {
            if (((pen_x + int_adv)>>6)>=(*width))
            {
            	if(len){*len=(int)strlen((char*)text);}
				cropped=TRUE;
            	
            	if (bDot) {
            		pen_x += (CalcCharWidth(font, '.') * 3);
            		while (i > 0 && (pen_x>>6) > (*width)-2) pen_x -= CalcCharWidth(font, text[--i]);
					while (i > 0 && text[i-1] <= ' ') pen_x -= CalcCharWidth(font, text[--i]);
					if (i > 0) strcpy(text + i, "..."), i += 3;
            	}
                break;
            }
        }
        i++;
        pen_x += int_adv;

        //t_min_bmp_bottom = max(t_min_bmp_bottom, font->m_bmpHeaderArray[text[i]].bitmap_rows-font->m_bmpHeaderArray[text[i]].slot_bitmap_top);
        //t_max_bmp_top = max(t_max_bmp_top, font->m_bmpHeaderArray[text[i]].slot_bitmap_top);
    }
    
	if(len && !cropped){*len=i;}
   	(*text_length) = i;
    (*width) = ((pen_x>>6)/2+1)*2;

    //font->m_fontHeight = max(font->m_fontHeight, t_min_bmp_bottom+t_max_bmp_top);

    return 0;
}

//////////////////////////////////////////////////////////////////////////
int RenderString(word region, FONT *font, unsigned char* text, int text_length, int width, word** image)
{
    int              pen_x, pen_y;
    int              y_offset, x_offset;
    unsigned char   *img;      // whole string
    unsigned char   *pImg;        
    word            *maxImagePtr; 
    word            *pAntialiasmap;
    word            *imagePtr;
    unsigned char    pixel;
    unsigned char   *bitmap;  // character bitmap
    unsigned char   *ptr=text;

    if (font==NULL || font->m_bmpHeaderArray==NULL)
    {
        return -1;
    }

#ifdef NO_ALLOC
    img = font->m_grayBuffer;
#else
    // Create bitmap buffer
    img = (unsigned char*)TAP_MemAlloc(width * font->m_fontHeight * sizeof(unsigned char));
    if (img==NULL)
    {
        return -2;
    }
#endif

	memset(img, 0, width*font->m_fontHeight);

    // Render string to a buffer
    pen_y=font->m_fontBaseline;    
    pen_x=-font->m_bmpHeaderArray[text[0]].slot_bitmap_left;
    while(*ptr)
    {
        LOAD_CHAR(font, *ptr, &bitmap);
        draw_bitmap(font, bitmap, img, width, font->m_fontHeight, 
        			pen_x+font->m_bmpHeaderArray[*ptr].slot_bitmap_left, 
                    pen_y-font->m_bmpHeaderArray[*ptr].slot_bitmap_top, 
                    font->m_bmpHeaderArray[*ptr].bitmap_rows, font->m_bmpHeaderArray[*ptr].bitmap_width);

        pen_x += font->m_bmpHeaderArray[*ptr].slot_advance_x >> 6; // increment pen position
//        pen_y += font->m_bmpHeaderArray[*ptr].slot_advance_y >> 6; // increment pen position
        *ptr++;
    }

#ifdef NO_ALLOC
    (*image) = font->m_wordBuffer;
#else
    (*image) = (word*)TAP_MemAlloc(width * font->m_fontHeight * sizeof(word)); // word
    if ((*image)==NULL)
    {
        return -2;
    }
#endif

    imagePtr = (*image);

    // Transfer buffer to the image
    maxImagePtr=&(imagePtr[font->m_fontHeight*width]);
    pImg=img;            

    pAntialiasmap=font->m_antialiasmap;
    while(imagePtr<maxImagePtr)
    {
		*imagePtr = pAntialiasmap[(*pImg)>>4];
		imagePtr++;
		pImg++;
    }
#ifdef NO_ALLOC
    ;
#else
    TAP_MemFree(img);
#endif

    return 0;
}

//////////////////////////////////////////////////////////////////////////
void draw_bitmap(FONT *font, unsigned char* bitmap, unsigned char *image, int width, int height, int x_offset, int y_offset, int bitmap_rows, int bitmap_width)
{
    int  i, j;
    unsigned char *pixel=bitmap;
    unsigned char *dest=image;

	int startY;
	int startX;
	int endX;
	int endY;

	startY=y_offset;
	endY=bitmap_rows + y_offset;

	startX=x_offset;
	endX=bitmap_width + x_offset;
	
	if(endY<height && endX<width)
	{
	    for(j=startY; j<endY; j++)
	    {
	    	dest=&(image[j*width+startX]);
		    for(i=startX; i<endX; i++)
	        {
	            *dest|=*pixel;
	            dest++;
	            pixel++;
		    }
	    }
	}
	else if(endY>=height)
	{
		if(endX<width)
		{
			// Only y is a problem
		    for(j=startY; j<height; j++)
		    {
		    	dest=&(image[j*width+startX]);
			    for(i=startX; i<endX; i++)
		        {
		            *dest|=*pixel;
		            dest++;
		            pixel++;
			    }
		    }
		    pixel+=((endY-j) * (endX-startX));
		}
		else
		{
			// Both are a problem
		    for(j=startY; j<height; j++)
		    {
		    	dest=&(image[j*width+startX]);
			    for(i=startX; i<width; i++)
		        {
		            *dest|=*pixel;
		            dest++;
		            pixel++;
			    }
	
			    pixel+=(endX-i);
		    }

		    pixel+=((endY-j) * (endX-startX));
		}		
	}
	else
	{
		// Only x is a problem
	    for(j=startY; j<endY; j++)
	    {
	    	dest=&(image[j*width+startX]);
		    for(i=startX; i<width; i++)
	        {
	            *dest|=*pixel;
	            dest++;
	            pixel++;
		    }
		    
		    pixel+=(endX-i);
	    }
	}
}

//////////////////////////////////////////////////////////////////////////
// computes 16 anti-aliasing steps trough RGB space
void ComputeAntialiasingMap(FONT *font, word foreColor, word antialias_backColor, word backColor)
{
    int dimmer=8, i;
    int oDimmer=255-dimmer;
    int fr, fg, fb, br, bg, bb;

    if (foreColor!=backColor)
    {
        fr = GETR(foreColor); fg = GETG(foreColor);  fb = GETB(foreColor);
        br = GETR(antialias_backColor); bg = GETG(antialias_backColor);  bb = GETB(antialias_backColor);

        for(i=0; i<16; i++)
        {
            font->m_antialiasmap[i] = RGB( (fr*dimmer+oDimmer*br)>>8, (fg*dimmer+oDimmer*bg)>>8, (fb*dimmer+oDimmer*bb)>>8);
            dimmer += 16;
	    	oDimmer=255-dimmer;
        }
        font->m_antialiasmap[0] = backColor;
        font->m_antialiasmap[15] = foreColor;
    }
    else
    {
        for(i=0; i<16; i++)
        {
            font->m_antialiasmap[i] = backColor;
        }
    }

}

bool isValidFont(int i)
{
	if (i == 0)
		return TRUE;

	return fonts[i].small_exists && fonts[i].medium_exists && fonts[i].large_exists;
}

int getFontIndex(char *name)
{
	int i;

	for (i = 0; i < font_count; i++) {
		if (strcmp(fonts[i].font_name, name) == 0)
			return i;
	}

	return -1;
}


bool loadFontName(char *name)
{
	char buffer[256];
	int index;
	bool size;
	size_t length;

	length = strlen(name);
	if (length > 10 && strcmp(name + length - 10, "_small.fnt") == 0)
		size = 0;
	else if (length > 11 && strcmp(name + length - 11, "_medium.fnt") == 0)
		size = 1;
	else if (length > 10 && strcmp(name + length - 10, "_large.fnt") == 0)
		size = 2;
	else
		return FALSE;

	memset(buffer, '\0', sizeof(buffer));
	strncpy(buffer, name, length - (size == 1 ? 11 : 10));

	index = getFontIndex(buffer);

	if (index < 0) {
		index = font_count;
		strcpy(fonts[index].font_name, buffer);
		fonts[index].small_exists= FALSE;
		fonts[index].medium_exists = FALSE;
		fonts[index].large_exists = FALSE;
		//TAP_Print("font: %s\n", fonts[index].font_name);
		++font_count;
	}
	if (size == 0)
		fonts[index].small_exists = TRUE;
	if (size == 1)
		fonts[index].medium_exists = TRUE;
	if (size == 2)
		fonts[index].large_exists = TRUE;

	return fonts[index].small_exists && fonts[index].medium_exists && fonts[index].large_exists;
}

int compareFonts(const void *s1, const void *s2)
{
	_font *font_1 = (_font*) s1;
	_font *font_2 = (_font*) s2;

	if (strcmp(font_1->font_name, "Default") == 0)
		return -1;

	if (strcmp(font_2->font_name, "Default") == 0)
		return 1;

	// if we get here, default to order by name
	return strcmp(font_1->font_name, font_2->font_name);
}

bool loadFonts()
{
	TYPE_File file;
	dword i;

	current_font = 0;

	strcpy(fonts[0].font_name, "Default");
	font_count = 1;

	if (ChangeDirFonts()) {
		i = TAP_Hdd_FindFirst(&file);
		while(i--) {
			if (isFont(file.name))
				loadFontName(file.name);

			if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
				break;
		}

//		qsort(fonts, font_count, sizeof(fonts[0]), compareFonts);
	}

	// match loaded fonts to config
	for (i = 1; i < font_count; i++) {
#ifndef WIN32
		if (strcmp(font_name, fonts[i].font_name) == 0 && isValidFont(i)) {
#else
		if (isValidFont(i)) {
#endif
			current_font = i;
			break;
		}
	}

	//TAP_Print("Current font %s, out of %d fonts\n", fonts[current_font].font_name, font_count);

	if (current_font > 0)
		loadFont();

	return (current_font > 0);
}

bool loadNewFonts()
{
	TYPE_File file;
	dword i;
	char current_font_name[100];

	strcpy(current_font_name, fonts[current_font].font_name);

	if (ChangeDirFonts()) {
		//TAP_Print("Load new fonts\n");

		i = TAP_Hdd_FindFirst(&file);
		while(i--) {
			if (isFont(file.name))
				loadFontName(file.name);

			if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
				break;
		}

//		qsort(fonts, font_count, sizeof(fonts[0]), compareFonts);
	}

	// reset the current font pointer as it may have moved position
	for (i = 0; i < font_count; i++) {
		if (strcmp(fonts[i].font_name, current_font_name) == 0) {
			current_font = i;
			break;
		}
	}

	return TRUE;
}

void loadFont()
{
	char buffer[256];

	sprintf(buffer, "%s_small.fnt", fonts[current_font].font_name);
	Load_Font(&small_font, buffer);

	sprintf(buffer, "%s_medium.fnt", fonts[current_font].font_name);
	Load_Font(&medium_font, buffer);

	sprintf(buffer, "%s_large.fnt", fonts[current_font].font_name);
	Load_Font(&large_font, buffer);

	//TAP_Print("Small: baseline %d, height %d\n", small_font.m_fontBaseline, small_font.m_fontHeight);
	//TAP_Print("Medium: baseline %d, height %d\n", medium_font.m_fontBaseline, medium_font.m_fontHeight);
	//TAP_Print("Large: baseline %d, height %d\n", large_font.m_fontBaseline, large_font.m_fontHeight);

	applyHook();
}

void switchFont()
{
	//TAP_Print("New font %s\n", fonts[current_font].font_name);

	deleteFont();

	if (current_font > 0) {
		loadFont();
	}
	else {
		removeHook();
	}
}

void adjustAntialiasing()
{
	small_font.antialias_factor = antialias_override;
	medium_font.antialias_factor = antialias_override;
	large_font.antialias_factor = antialias_override;
}

void deleteFontFiles()
{
	char file_name[100];

	TAP_SPrint(file_name, "%s_small.fnt", fonts[current_font].font_name);
	TAP_Hdd_Delete(file_name);
	TAP_SPrint(file_name, "%s_medium.fnt", fonts[current_font].font_name);
	TAP_Hdd_Delete(file_name);
	TAP_SPrint(file_name, "%s_large.fnt", fonts[current_font].font_name);
	TAP_Hdd_Delete(file_name);
}

void shuffleFontsDown(int deleted)
{
	int i;

	for (i = deleted; i < (font_count - 1); i++)
		fonts[i] = fonts[i+1];

	font_count--;
	while (current_font >= font_count || !isValidFont(current_font))
		current_font = (current_font + 1) % font_count;

	switchFont();
}

void deleteFont()
{
	Delete_Font(&small_font);
	Delete_Font(&medium_font);
	Delete_Font(&large_font);
}

//////////////////////////////////////////////////////////////////////////
// Hook    for TAP_Osd_GetW
#ifdef HOOK

int TAP_Osd_GetW_HOOK(const char *str, byte fntType, byte fntSize)
{
    int retval=0, textlen;
    FONT *font=NULL;

    switch(fntSize)
    {
		case FNT_Size_1419:
			font = &small_font;
			break;
		case FNT_Size_1622:
			font = &medium_font;
			break;
		case FNT_Size_1926:
			font = &large_font;
			break;
    }

	CalcSize(font, (unsigned char*) str, &retval, &textlen, 0, NULL);
    return retval;
}

//////////////////////////////////////////////////////////////////////////
// Hook    for TAP_Osd_PutS
// fntType : font type. It SHOULD be 0.
// fntSize : font size. FNT_Size_1419, FNT_Size_1622 or FNT_Size_1926
// bDot    : It decides to print  in case that the string is over the maxX. - not used so far
int TAP_Osd_PutS_HOOK(word rgn, dword x, dword y, dword maxX, const char *str, word fcolor, word bcolor, byte fntType, byte fntSize, byte bDot, byte align)
{
    int retval=0, new_y;
    FONT *font=NULL;

    switch(fntSize)
    {
		case FNT_Size_1419:
			font = &small_font;
			new_y = (font->m_fontHeight < 17) ? y+2 : y;
			break;
		case FNT_Size_1622:
			font = &medium_font;
			new_y = (font->m_fontHeight < 21) ? y+2 : y;
			new_y = (font->m_fontBaseline < 14) ? new_y+2 : new_y;
			break;
		case FNT_Size_1926:
			font = &large_font;
			new_y = (font->m_fontHeight < 25) ? y+2 : y;
			break;
    }

	return TAP_Osd_PutS_Font(rgn, x, new_y, maxX, (unsigned char*) str, fcolor, bcolor, font, align, bDot);
}

//////////////////////////////////////////////////////////////////////////
// Hook    for TAP_Osd_PutStringAf_HOOK
// fntType : font type. It SHOULD be 0.
// fntSize : font size. FNT_Size_1419, FNT_Size_1622 or FNT_Size_1926
int TAP_Osd_PutStringAf_HOOK(word rgn, dword x, dword y, dword maxX, const char * str, word fcolor, word bcolor, byte fntType, byte fntSize, byte nextLine)
{
   int retval=0, new_y;
   FONT *font=NULL;

   switch(fntSize)
   {
       case FNT_Size_1419:
           font = &small_font;
           new_y = (font->m_fontHeight < 17) ? y+2 : y;
           break;
       case FNT_Size_1622:
           font = &medium_font;
           new_y = (font->m_fontHeight < 21) ? y+2 : y;
		   new_y = (font->m_fontBaseline < 14) ? new_y+2 : new_y;
           break;
       case FNT_Size_1926:
           font = &large_font;
           new_y = (font->m_fontHeight < 25) ? y+2 : y;
           break;
   }

   return TAP_Osd_PutS_Font(rgn, x, new_y, maxX, (unsigned char*) str, fcolor, bcolor, font, ALIGN_LEFT, 0);
}

//////////////////////////////////////////////////////////////////////////
// Hook    for TAP_Osd_PutStringAf_HOOK
// fntType : font type. It SHOULD be 0.
// fntSize : font size. FNT_Size_1419, FNT_Size_1622 or FNT_Size_1926
int TAP_Osd_PutString_HOOK(word rgn, dword x, dword y, dword maxX, const char * str, word fcolor, word bcolor, byte fntType, byte fntSize, byte nextLine)
{
   int retval=0, new_y;
   FONT *font=NULL;

   switch(fntSize)
   {
       case FNT_Size_1419:
           font = &small_font;
           new_y = (font->m_fontHeight < 17) ? y+2 : y;
           break;
       case FNT_Size_1622:
           font = &medium_font;
           new_y = (font->m_fontHeight < 21) ? y+2 : y;
		   new_y = (font->m_fontBaseline < 14) ? new_y+2 : new_y;
           break;
       case FNT_Size_1926:
           font = &large_font;
           new_y = (font->m_fontHeight < 25) ? y+2 : y;
           break;
   }

   return TAP_Osd_PutS_Font(rgn, x, new_y, maxX, (unsigned char*) str, fcolor, bcolor, font, ALIGN_LEFT, 0);
}
#endif //HOOK
